/*
    This file is part of the LCDGraphics library for the Weebox.

    LCDGraphics is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with LCDGraphics.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef INCLUDED_LCDGRAPHICS_IDEVICE_H
#define INCLUDED_LCDGRAPHICS_IDEVICE_H

namespace LCDGraphics
{
	class IDevice
	{
	public:
		virtual ~IDevice() {}

		virtual bool SetInstruction(unsigned char iInstruction) = 0;
		virtual bool SetData(unsigned char iData) = 0;
		virtual bool SetData(const unsigned char* iData, unsigned int iDataCount) = 0;
		virtual bool GetData(unsigned char* oData, unsigned int iDataCount) = 0;
	};

}

#endif
